SET height = '750';
SET type = 'line';
SET marker = 4;
SET max_line_series = 50;

SET unit_count_chart = (SELECT v#>>'{}' FROM json_array_elements($unit_count::json) j(v) LIMIT 1);
SET display_by_count = (SELECT count(*) FROM json_array_elements($unit_count::json) j(v)) == 1
AND (EXISTS (SELECT 1 FROM sqlpage_txn WHERE unit = $unit_count_chart LIMIT 1));
SET display_by_mass = (EXISTS (SELECT 1 FROM sqlpage_txn WHERE unit = $unit_mass LIMIT 1));
SET display_by_volume = (EXISTS (SELECT 1 FROM sqlpage_txn WHERE unit = $unit_volume LIMIT 1));

SELECT 'chart' AS component
, 'Cost by Weight' AS title
, $height AS height
, '$/'||$unit_mass AS ytitle
, CASE
    WHEN (
      SELECT count(DISTINCT product)
      FROM sqlpage_txn
      WHERE unit = $unit_mass
    ) > $max_line_series::numeric
    THEN 'scatter' ELSE $type
  END AS type
, $log_scale = 'true' AS logarithmic
, TRUE AS time
, 0 AS ymin
, $marker AS marker
;
SELECT product AS series
, ts AS x
, to_char(price/quantity, 'FM999999999.000') AS y
FROM sqlpage_txn
WHERE unit = $unit_mass
ORDER BY ts
;

SELECT 'chart' AS component
, 'Cost by Volume' AS title
, $height AS height
, '$/'||$unit_volume AS ytitle
, CASE
    WHEN (
      SELECT count(DISTINCT product)
      FROM sqlpage_txn
      WHERE unit = $unit_volume
    ) > $max_line_series::numeric
    THEN 'scatter' ELSE $type
  END AS type
, $log_scale::bool AS logarithmic
, TRUE AS time
, 0 AS ymin
, $marker AS marker
;
SELECT product AS series
, ts AS x
, to_char(price/quantity, 'FM999999999.000') AS y
FROM sqlpage_txn
WHERE unit = $unit_volume
ORDER BY ts
;

SELECT 'chart' AS component
, 'Cost by Count' AS title
, $height AS height
, '$/'||$unit_count_chart AS ytitle
, CASE
    WHEN (
      SELECT count(DISTINCT product)
      FROM sqlpage_txn
      WHERE unit = $unit_count_chart
    ) > $max_line_series::numeric
    THEN 'scatter' ELSE $type
  END AS type
, $log_scale::bool AS logarithmic
, TRUE AS time
, 0 AS ymin
, $marker AS marker
WHERE $display_by_count::bool
;
SELECT product AS series
, ts AS x
, to_char(price/quantity, 'FM999999999.000') AS y
FROM sqlpage_txn
WHERE $display_by_count::bool
AND unit = $unit_count_chart
ORDER BY ts
;